#include <stdlib.h>
#include <stdio.h>

#include "arriere.h"

FILE *
arriere_fopen (char *nomdufichier, char *mode)
{

  FILE *flot;

  flot = fopen (nomdufichier, mode);
  if (flot != NULL)
    fseek (flot, 0, SEEK_END);

  return flot;
}

/*
  Lire un  caractre  gauche.
  Algorithme:
  1 - se dplacer  gauche,
  si cela n'est pas possible retourner BOF (beginning of file).
  2 - lire le caractre
  3 - se replacer sur le caractre qu'on vient de lire
*/

int
arriere_fgetc (FILE * flot)
{
  int c;

  if (fseek (flot, -1, SEEK_CUR) != 0)	/* Se deplacer un pas en arriere */
    return BOF;
  c = fgetc (flot);		/* Lire le caractere currant */
  fseek (flot, -1, SEEK_CUR);	/* Se replacer en arriere */

  return c;
}

/*
  Lire une ligne  gauche.
  Algorithme: 
  comme evident, en utilisant arriere_fgetc
*/

char *
arriere_fgets (char *buffer, int taille, FILE * flot)
{
  int c, i = 0;

  /* 
     Les erreur arrivent au dbut si :
     1 : il n'y a pas d'espace pour ajouter le terminateur de chane
     2 : il n'y a rien a lire sur le fichier
   */
  if (taille <= 0 || (c = arriere_fgetc (flot)) == BOF)
    return NULL;

  while (c != BOF && i < (taille - 1))
    /* taille -1 :  laisser la place pour le terminateur de chane */
    {
      buffer[i++] = c;
      
      if(c == '\n')
	break;
      /* Lire le prochain caractre */
      c = arriere_fgetc (flot);
    }

  buffer[i] = 0;		/* Ajouter le terminateur de chane */

  return buffer;
}
