#include "monstdio.h"
#include <stdlib.h>
#include <sys/stat.h>

/* #include <unistd.h> */


#define MIN(x,y) ((x)<(y))?(x):(y)

/* Seulement le fflush d'un flot ouvert en ecriture */
/* est implement */
int monfflush(MONFILE *flot)
{
  if(!(flot->mode & O_WRONLY))
    return -ERR_NOT_WR ;
      
  write(flot->fd,flot->tampon,flot->seek);
  flot->seek=0;

  return 0;
}

MONFILE * monfopen(char *fic,char *mode)
{
  MONFILE *ret;
  int fd;
  mode_t imode;

  if(strcmp(mode,"r") ==  0)
    imode = O_RDONLY;
  else if(strcmp(mode,"w") ==  0)
    /* crer le fichier s'il n'existe pas, 
       craser le fichier s'il existe dj */
    imode = O_WRONLY | O_CREAT | O_TRUNC;
  else
    return NULL;
  
  fd = open(fic, imode , S_IRUSR | S_IWUSR);
  /* droits  la cration : rw------- */
  if(fd < 0)
    return NULL;
  
  ret=malloc(sizeof(MONFILE));
  if(ret == NULL)
    {
      close(fd);
      return NULL;
    }

  /* initialisation de la structure */
  ret->seek=0;
  ret->fd= fd;
  ret->mode=imode;

  return ret;
}

int monfclose(MONFILE *flot)
{
  if(flot == NULL)
    return -1;
  
  close(flot->fd);
  free(flot);
  return 0;
}

/* Implmentations trs lmentaire */
int monfprintf(MONFILE *flot, const char * format)
{
  int len_format = strlen(format), len_ptr;
  const char *ptr = format;
  int no_a_copier, tot_copie = 0;

  while(tot_copie != len_format)
    {
      len_ptr = strlen(ptr);
      no_a_copier = MIN(SIZETAMPON - flot->seek,len_ptr);
      
      memcpy(flot->tampon + flot->seek, format,no_a_copier);
      flot->seek +=no_a_copier;
      if(flot->seek == SIZETAMPON)
	monfflush(flot);
      
      tot_copie +=no_a_copier;
      ptr += no_a_copier;
    }
  return 0;
}
